## Var

Vous allez devoir répondre à un questionnaire sur votre compréhension des variables.

Seuil de réussite: 80%

Fonction du quiz: Formative/Certificative

Q1 : Quelle affirmation est juste ?
Type de question: 
- Réponse correcte unique 

Réponses :
- La déclaration d’une variable doit précéder son utilisation Correct -> Il faut toujours déclarer une variable avant de pouvoir l'utiliser. La déclaration de la variable permet de "réserver" sa place en mémoire et de savoir quel type de données il faudra y enregistrer. Il est donc nécessaire de le faire avant de pouvoir utiliser la variable.
- La déclaration d'une variable avant son utilisation est optionnelle. Incorrect -> Une variable ne pas peut être utilisée si elle n'a pas été préalablement déclarée. Une variable qui n'est pas déclarée est considérée comme inconnue par le programme. Sa déclaration permet d'une certaine façon de la décrire pour pouvoir l'utiliser. Sans déclaration préalable, le programme n'est pas en mesure d'utiliser une variable.
- La déclaration d’une variable doit toujours contenir son type. Incorrect -> Indiquer explicitement le type d'une variable n'est pas une obligation. Son type sera implicitement déduit de la valeur initiale qui lui sera attribuée.


Q2 : Quelle affirmation est juste ?
Type de question: 
- Réponse correctes multiples

Réponses :
- Une variable peut contenir plusieurs valeurs à un moment donné du déroulement du programme. Incorrect -> Une variable ne contient qu'une seule valeur à tout moment. Cette valeur peut changer au cours de l'exécution du programme, mais toute nouvelle valeur affectée à une variable "écrase" la valeur précédemment enregistrée.
- Une variable peut contenir plusieurs valeurs à différents moments du déroulement du programme. Correct -> Le contenu d'une variable peut changer dans le cours de l'exécution du programme. Il est possible d'affecter une nouvelle valeur à une variable. A un moment donnée, elle ne peut contenir qu'une seule valeur.
- Une variable peut ne pas contenir de valeur. Incorrect -> En effet, une variable contient toujours une valeur. Dans certaines situations cette valeur peut être définie implicitement.

Q3 : La déclaration d’une variable définit :
Type de question: 
- Réponses correctes multiples

Réponses :
- Le nom de la variable Correct -> La déclaration permet de définir le nom de la variable. Ce nom sert à identifier la variable.
- L’affectation de la variable Correct -> La déclaration permet d'affecter une valeur à la variable.
- Le type de valeurs de la variable Correct -> La déclaration permet d'attribuer un type de valeurs à une variable. Le type de la variable peut être défini explicitement en indiquant son nom ou implicitement à partir de la valeur qui est affectée à la variable. Si la déclaration précise un type et une valeur, il faut qu'ils soient compatibles.
- La durée de vie de la variable Incorrect -> La déclaration d'une variable ne définit pas sa durée de vie, c'est à dire le temps pendant lequel la variable va exister. Nous aurons l'occasion de voir plus tard que l'endroit où la déclaration d'une variable est faite dans un programme détermine sa durée de vie.


Q4 : Si une variable est affectée à elle-même le résultat est :
Type de question: 
- Réponse correcte unique 

Réponses :
- Ce n’est pas possible de réaliser une telle opération Incorrect -> Il est possible de réaliser cette opération, même si elle paraît inutile ou stupide.
- La valeur de la variable est effacée Incorrect -> La valeur de la variable n'est pas effacée. La valeur de la variable est bien modifiée, mais la valeur qui lui affectée est la valeur courante de la variable. Elle garde donc sa valeur.
- La variable conserve la même valeur Correct-> Le résultat final est identique, la variable conserve la même valeur: la valeur de la variable est affectée à elle-même. Le résultat de l'opération ne change donc pas la valeur de la variable. Cette opération est réalisable, mais bien entendu inutile, puisqu'elle ne change pas la valeur de la variable.


Q5 : 
```
Déclarer la variable entière  A
Déclarer la variable entière B

Affecter la valeur 10 à A
Affecter la valeur 5 à B
Affecter la valeur de B à A
Affecter la valeur de A à B
```

Quelles sont les valeurs finales de A et B ?

Type de question: 
- Réponse correcte unique 

Réponses :
- A vaut 5 et B vaut 10 Incorrect -> A vaut bien 5, mais B ne vaut pas 10.
- A vaut 5 et B vaut 5 Correct -> En effet, B contient 5, A copie la valeur de B, 5, qui est ensuite de nouveau copiée dans B. 
- A vaut 10 et B vaut 5  Incorrect ->  A ne vaut pas 10 et B ne vaut pas 5.


Q6 :
```
Déclarer la variable entière A
Déclarer la variable entière B
Déclarer la variable entière C

Affecter la valeur 10 à A
Affecter la valeur 5 à B
Affecter la valeur de A à C
Affecter la valeur de B à A
Affecter la valeur de C à B
```

Quelles sont les valeurs de A et B ?

Type de question: 
- Réponse correcte unique 

Réponses :
- A vaut 5 et B vaut 10  Correct -> Les valeurs initiales de B et A sont échangées en utilisant la variable C comme intermédiaire.
- A vaut 5 et B vaut 5 Incorrect -> A vaut bien 5, mais pas B.
- A vaut 10 et B vaut 5 Incorrect -> A ne vaut pas 10 et B ne vaut pas 5.


Q7 : 
```
Déclarer la variable entière A
Déclarer la variable entière B
Déclarer la variable entière C
Affecter la valeur 10 à A
Affecter la valeur 5 à B
Affecter le résultat de A + B à C
Obtenir une valeur au clavier pour A
Obtenir une valeur au clavier pour B
``` 

Quelles sont les valeurs finales de A, B et C ?

Type de question: 
- Réponse correcte unique 

Réponses :

- A vaut 10, B vaut 5 et C vaut 15 Incorrect -> C vaut bien 15, mais A et B ont changé de valeur suite à la saisie au clavier. Les valeurs de A et de B ne peuvent pas être connues. Elles dépendent de ce que l'utilisateur aura saisi au clavier.
- A et B ont des valeurs inconnues, C vaut 15 Correct -> C contient la somme des valeurs précédentes de A et B qui sont maintenant inconnues. Leurs valeurs dépendent de ce que l'utilisateur aura saisi au clavier.
- A, B et C ont des valeurs inconnues Incorrect -> La valeur de C est connue.


Q8 : 
```
Déclarer la variable entière A
Déclarer la variable entière B
Déclarer la variable entière C
Affecter la valeur 10 à A
Affecter la valeur 5 à B
Affecter la valeur 20 à C
Affecter le résultat de A + B à C
Affecter le résultat de A + C à B
Affecter le résultat de C + B à C 
```

Quelles sont les valeurs de A, B et C ?

Type de question: 
- Réponse correcte unique 

Réponses :
- A vaut 10, B vaut 5 et C vaut 15 Incorrect -> A vaut bien 10, B ne vaut pas 5 et C vaut 15 quelle obtient lors de sa seconde affectation, comme résultat de A + B.
- A vaut 10, B vaut 25 et C vaut 40 Correct-> A ne change pas de valeur après son initialisation à 10, B change une fois de valeur après son initialisation à 5 et C chaneg deux fois de valeurs après son initialisation à la valeur 20.
- A vaut 10, B vaut 25 et C vaut 45 Incorrect -> B et C sont fausses, les deux sont redéfinies.
- A vaut 10, B vaut 30 et C vaut 25 Incorrect -> La somme des valeurs dans B n'est jamais égale à 30.


Q9 : 
```
Déclarer la variable entière A
Déclarer la variable entière B
Déclarer la variable entière C
Affecter la valeur 10 à A
Affecter la valeur 5 à B
Affecter le résultat de A + B à C
Obtenir une valeur au clavier pour A
Obtenir une valeur au clavier pour B
Affecter le résultat de A + B à C
```

Quelles sont les valeurs finales de A, B et C ?

Type de question: 
- Réponse correcte unique 

Réponses :

- A vaut 10, B vaut 5 et C vaut 15 Incorrect -> A ne vaut pas 10, B ne vaut pas 5 et C ne vaut pas 15.
- A et B ont des valeurs inconnues, C vaut 15 Incorrect -> A et B ont bien des valeurs inconnues: elles dépendent des valeurs que l'utilisateur aura saisi au clavier. C ne vaut pas 15.
- A, B et C ont des valeurs inconnues Correct -> A, B et C ont des valeurs inconnues. Les valeurs finales de A et B sont inconnues car elle dépendent de ce que l'utilisateur aura saisi au clavier. La valeur de C est aussi inconnue, car elle est le résultat de l'addition des valeurs finales de A et B.