## Var

This quiz is designed to measure your understanding of variables.

Passing grade: 80%

Quiz type: Instructional/Certifying

Q1: Which statement is true?
Question type: 
- Single correct answer 

Answers:
- A variable must be declared before it can be used Correct -> You cannot use a variable unless it has been declared. Declaring a variable “reserves” its space in the memory and indicates the type of data to be stored there. Therefore, this must necessarily be done before a variable can be used.
- A variable may or may not be declared before it can be used. Wrong -> A variable cannot be used if it has not previously been declared. An undeclared variable is considered an unknown by the program. The declaration is a way of describing the variable for future use. If a variable has not been declared beforehand, the program will not be able to use it.
- A variable’s declaration must always include the variable type. Wrong -> Explicitly indicating the variable type is not a must. A variable’s type will be inferred by Scala from the first value assigned to it.


Q2: Which statement is true?
Question type: 
- Multiple correct answers

Answers:
- A variable can contain several different values at a given point in time of a program’s execution. Wrong –> At any given time, a variable contains only one value. This value may change during the program’s execution, but any new value assigned to a variable "overwrites" the previously stored value.
- A variable can contain different values at a various points in time of a program’s execution. Correct -> The content of a variable can change during a program’s execution. A new value can be assigned to a variable. At any given time, however, a variable can only contain one value.
- A variable cannot contain a value. Wrong -> In fact, a variable always contains a value. In some situations, this value is defined implicitly.

Q3: The variable declaration defines: 
Question type: 
- Multiple correct answers

Answers:
- The name of the variable Correct -> Declaring a variable allows you to give it a name. This name is used to identify the variable.
- The value assigned to the variable Correct -> Declaring a variable allows you to give it a value.
- The variable’s value type Correct -> Declaring a variable allows you to give it a value type. The value type can be defined explicitly, by indicating its name, or implicitly, based on the value assigned to the variable. If a declaration specifies type and value, these two must be compatible.
- The variable’s lifetime Wrong -> A variable’s declaration does not specify its lifetime, that is, the length of time it will exist. We will learn later on that the location within the program of a variable’s declaration determines its lifetime.


Q4: If a variable is set to itself, the result is:
Question type: 
- Single correct answer 

Answers:
- Such an operation is not possible Wrong -> This operation can be done, even though it might seem useless or stupid.
- The variable’s value is erased Wrong -> The variable’s value is not erased. Granted, the variable’s value is modified, but the newly-assigned value is the variable’s existing value. Thus the value does not change.
- The value remains unchanged Correct -> The final output is the same; the variable stays at the same value since it is set to its own value. Therefore, the result of the operation does not change the variable’s value. This operation is possible, but clearly useless, since it effects no change in the variable’s value.


Q5: 
```
Declare integer variable A
Declare integer variable B

Assign value 10 to A
Assign value 5 to B
Assign the value of B to A
Assign the value of A to B
```

What are the final values of A and B?

Question type: 
- Single correct answer 

Answers:
- A has value 5 and B has value 10 Wrong -> While A does have value 5, B does not have value 10.
- A has value 5 and B has value 5 Correct -> Yes, because B is set to 5, and A reproduces the value of B, and the value of A is then copied into B. 
- A has value 10 and B has value 5  Wrong ->  A does not have value 10, although B does have value 5.


Q6:
```
Declare integer variable A
Declare integer variable B
Declare integer variable C

Assign value 10 to A
Assign value 5 to B
Assign the value of A to C
Assign the value of B to A
Assign the value of C to B
```

What are the values of A and B?

Question type: 
- Single correct answer 

Answers:
- A has value 5 and B has value 10 Correct -> The initial values of B and A have been swapped using variable C as intermediary.
- A has value 5 and B has value 5 Incorrect -> While A does have value 5, B does not have value 5.
- A has value 10 and B has value 5 Wrong -> A does not have value 10, nor does B have value 5.


Q7: 
```
Declare integer variable A
Declare integer variable B
Declare integer variable C
Assign value 10 to A
Assign value 5 to B
Assign the result of A + B to C
Obtain a keyboard value for A
Obtain a keyboard value for B
``` 

What are the final values of A, B and C?

Question type: 
- Single correct answer 

Answers:

- A has value 10, B has value 5 and C has value 15 Wrong -> While C does have value 15, the values of A and B have been modified by the user’s keyboard input. The values of A and B cannot be known. They depend on what the user has typed in with the keyboard.
- A and B are unknown values, C has value 15 Correct -> C contains the sum of A and B’s previous values, before A and B became unknown. A and B’s current values depend on what the user has typed in with the keyboard.
- A, B and C are unknown values Wrong -> C’s value is known.


Q8: 
```
Declare integer variable A
Declare integer variable B
Declare integer variable C
Assign value 10 to A
Assign value 5 to B
Assign value 20 to C
Assign the result of A + B to C
Assign the result of A + C to B
Assign the result of C + B to C 
```

What are the values of A, B and C?

Question type: 
- Single correct answer 

Answers:
- A has value 10, B has value 5 and C has value 15 Wrong -> Although A does have value 10 and C does have value 15, obtained after its second assignment as the result of A + B, B does not have value 5.
- A has value 10, B has value 25 and C has value 40 Correct-> A’s value does not change after having been initially set at 10; B’s value, initially set at 5, changes once; and C’s value, initially set at 20, changes twice.
- A has value 10, B has value 25 and C has value 45 Wrong -> The values of B and C are wrong, both have been redefined.
- A has value 10, B has value 30 and C has value 25 Wrong -> The sum of the values in B is never 30.


Q9: 
```
Declare integer variable A
Declare integer variable B
Declare integer variable C
Assign value 10 to A
Assign value 5 to B
Assign the result of A + B to C
Obtain a keyboard value for A
Obtain a keyboard value for B
Assign the result of A + B to C
```

What are the final values of A, B and C?

Question type: 
- Single correct answer 

Answers:

- A has value 10, B has value 5 and C has value 15 Wrong -> All three of those values are wrong.
- A and B are unknown, C has value 5 Wrong -> A and B are indeed unknown, as they depend on the user’s input. But C does not have value 15.
- The values of A, B and C are unknown. Correct -> A, B and C all have unknown values. The final values of A and B are unknown because they depend on the user’s keyboard input. C’s value is likewise unknown, since it is the result of adding the final values of A and B.