## Instructions : Séquentielle ou Conditionelle ou Itérative

Vous allez devoir répondre à un questionnaire sur des instructions en pseudo code. Vous devez déterminer de quel type est l'instruction et indiquer son effet.

Seuil de réussite: 80%

Fonction du quiz: Formative

Q1 : Sur une voiture, un capteur permet d’obtenir la vitesse du véhicule (qui est stockée dans la variable vitesse). Pour permettre de contrôler la vitesse du véhicule, on la compare à une vitesse maximale (qui est stockée dans une variable vitesseMax). Un voyant indique au conducteur la situation : il est vert si le véhicule est en dessous de la vitesse maximale, rouge sinon. Comment représenter la situation avec une instruction de contrôle alternative :

Type de question: 
- Réponses correctes multiples

Réponses :

```
Si (vitesse > que vitesseMax) alors Allumer voyant rouge
Allumer voyant vert 
```
Incorrect -> Ces instructions s'exécuteront, mais ne réaliseront pas ce qui est demandé: si la vitesse est plus grande que la vitesseMax, le voyant sera allumé au rouge, puis l'instruction qui suit immédiatement le si sera exécutée et le voyant sera immédiatement allumé au vert. Si la vitesse esy inférieure à vitesseMax, l'instruction pour allumer le voyant au rouge ne sera pas exécutée et l'instruction qui suit immédiatement le si sera exécutée et le voyant sera allumé au vert. Quelque soit la vitesse, le voyant sera finalement toujours au vert. 

```
Si (vitesse > que vitesseMax) alors Allumer voyant rouge
Sinon Allumer voyant Vert
```
Correct -> Ces instructions s'exécuteront et réaliseront ce qui est demandé. La vitesse est testée correctement (ici, l'intervalle de vitesses pour lesquelles la condition est vraie est [vitesseMax, +∞[) et les actions qui en dépendent, sont déclarées.

```
Si (vitesse < que vitesseMax ou vitesse = à vitesseMax) alors Allumer voyant vert
Sinon Allumer voyant rouge 
```
Correct -> Ces instructions sont correctes et réaliseront ce qui est demandé. En effet, la vitesse est testée correctement (ici, l'intervalle de vitesses pour lesquelles la condition est vraie est [-∞, vitesseMax]) et les actions qui en dépendent sont déclarées.

```
Si (vitesse > que vitesseMax) alors Allumer voyant rouge
Sinon Si (vitesse < que vitesseMax ou vitesse = à vitesseMax) Alors Allumer voyant Vert
```
Correct -> Ces instructions s'exécuteront et réaliseront ce qui est demandé. Cependant, elles seront considérées comme incorrectes: le deuxième si est inutile. Si c'est l'alternative du sinon qui est exécutée, c'est que la condition vitesse > vitesseMax est fausse et donc que la condition vitesse < vitesseMax ou vitesse = vitesseMax est forcément vraie. Le second si est donc inutile.


Q2 : On considère l’équation a x + b = 0. 

Voici le traitement qui est proposé pour calculer la valeur de x :
```
Déclarer la variable a
Déclarer la variable b
Déclarer la variable x
Obtenir une valeur au clavier pour a
Obtenir une valeur au clavier pour b
Affecter à x le résultat de b ÷ a
Afficher la valeur de x à l’écran
```
Ce traitement ne fonctionne pas dans certaines situations. Comment le corriger ?

Type de question: 
- Réponse correctes multiple

Réponses :

```
Déclarer la variable a
Déclarer la variable b
Déclarer la variable x
Si (a = à 0) alors Obtenir une valeur au clavier pour a
Obtenir une valeur au clavier pour b
Affecter à x le résultat de b ÷ a
Afficher la valeur de x à l’écran
```
Incorrect -> Cette solution ne permet pas de calculer la valeur de x correctement. La valeur de a est testée avant d'être saisie au clavier.

```
Déclarer la variable a
Déclarer la variable b
Déclarer la variable x
Obtenir une valeur au clavier pour a
Obtenir une valeur au clavier pour b
Si (a n’est pas = à 0) alors Affecter à x le résultat de b ÷ a
Afficher la valeur de x à l’écran
```
Incorrect -> Cette solution ne permet pas de déterminer la valeur de x dans tous les cas. Pour le cas particulier ou a vaut 0, x ne sera pas calculé.


```
Déclarer la variable a
Déclarer la variable b
Déclarer la variable x
Obtenir une valeur au clavier pour a
Obtenir une valeur au clavier pour b
Si (a est = à 0) alors Afficher le message « pas de solution ou toutes les valeurs possibles de x sont solutions si b vaut 0 »
Sinon Affecter à x le résultat de b ÷ a
Afficher la valeur de x à l’écran
```

Correct-> Le test effectué sur a est correct et permet de déterminer la valeur de x dans tous les cas et et le programme n'aura jamais à calculer b ÷ 0 qui n'est pas possible.

```
Déclarer la variable a
Déclarer la variable b
Déclarer la variable x
Obtenir une valeur au clavier pour a
Obtenir une valeur au clavier pour b
Si (a n’est pas = à 0) alors Affecter à x le résultat de b ÷ a
Sinon Afficher la valeur de x à l’écran

```
Incorrect -> La valeur de x est calculée si a ne vaut pas 0, mais elle n'est pas affichée. Inversement, elle est affichée, mais pas calculée si a vaut 0.
```
Déclarer la variable a
Déclarer la variable b
Déclarer la variable x
Obtenir une valeur au clavier pour a
Si (a est = à 0) alors Afficher « pas de solution »
Sinon { Obtenir une valeur au clavier pour b
      Affecter à x le résultat de b ÷ a
      Afficher la valeur de x à l’écran
      }
      
Les { et } délimitent les instructions à exécuter pour le sinon.
```
Correct -> En effet, cette solution est juste. Si a est égal à 0, il n'y pas de solution possible. Sinon, on peut utiliser la valeur de b pour trouver x en divisant b par a, puis afficher la valeur de x.


Q3 : Un nombre est choisi au hasard - il est possible de calculer un nombre tiré au hasard - qu’un joueur doit deviner. Sa valeur est stockée dans la variable devinette. Comment peut-on réaliser le traitement qui permet de vérifier si le joueur a gagné (en imaginant que le joueur a un nombre illimité de tentatives) ? 

Type de question: 
- Réponse correcte unique 

Réponses :

```
Déclarer la variable devinette
Déclarer la variable choix
Choisir au hasard la valeur de devinette
Obtenir une valeur au clavier pour choix
Tant que (choix n’est pas = à devinette) Afficher le message « Essayer encore »
Afficher le message « Vous avez gagné »
```
Incorrect -> Si le choix saisi au clavier n'est pas le bon, alors, la boucle va continuellement afficher le message "Essayer encore" car la condition va rester vraie.

```
Déclarer la variable devinette
Déclarer la variable choix
Choisir la valeur de devinette
Obtenir une valeur au clavier pour choix
Si (choix n’est pas = à devinette) Alors Afficher le message « Essayer encore »
Sinon Afficher le message « Vous avez gagné »
```
Incorrect -> Cette solution ne permet de tester qu'un seul essai du joueur. Elle ne permet pas de répéter d'autres essais si il s'est trompé à sa première proposition.

```
Déclarer la variable devinette
Déclarer la variable choix
Choisir la valeur de devinette
Obtenir une valeur au clavier pour choix
Tant que (choix n’est pas = à devinette) {
          Afficher le message « Essayer encore »
          Obtenir une valeur au clavier pour choix
          Afficher le message « Vous avez gagné »
          }
          
Les { et } délimitent les instructions à répéter dans la boucle Tant que
```
Correct -> En effet, cette solution va permettre de répéter la saisie et le test d'une valeur jusqu'à ce qu'elle corresponde à la valeur tirée au hasard.

Q4 : Pour monter des blancs d’œufs en neige, il est nécessaire de les battre avec un fouet jusqu’à ce qu’il soit possible de retourner le récipient sans que les blancs glissent ou tombent du récipient. 

Type de question: 
- Réponse correcte unique 

Réponses :
Correct/Incorrect -> Feedback si sélectionné

```
Si (les blancs glissent ?) alors Battre une fois les blancs
```
Incorrect -> Cette solution ne va effectuer qu'un seul battement des blancs.
```
Tant que (les blancs glissent ?) Battre une fois les blancs
```
Correct -> Cette solution permet de répéter le battement des blancs jusqu'à ce qu'ils ne glissent plus.
```

Tant que (les blancs glissent ?) 
    Si (les blancs glissent ?) alors Battre une fois les blancs
```

Correct -> Cette solution fonctionne, mais elle sera toutefois considérée comme incorrecte, car le test Si imbriqué dans le Tant que est inutile. Si la boucle Tant que est exécutée, c'est que la condition "les blancs glissent" est vraie. Il est donc inutile de la tester avec le Si avant de battre une fois les blancs.

```
Si (les blancs glissent ?) alors 
    Tant que (les blancs glissent ?) Battre une fois les blancs
```
Correct -> Cette solution fonctionne, mais elle sera toutefois considérée comme incorrecte, car le le test Si est inutile. Il est inutile de tester si les blancs glissent avant la boucle Tant que qui va tester cette condition dès le début.