## Répondre à une problématique

Vous allez devoir répondre à un questionnaire sur l'implémentation et l'exécution d'un programme pour répondre à une problématique donnée.

Seuil de réussite: 80%

Fonction du quiz: Formative/ Certificative

Il vous est demandé d’écrire un programme qui détermine le prix TTC (avec TVA) d’un nombre donné d’un produit en fonction de son prix unitaire et de sa catégorie. Le programme doit bien entendu choisir le bon taux de TVA (7,7% ou 2,5%) pour faire le calcul en fonction de la catégorie du produit (le taux réduit est appliqué sur les denrées alimentaires, les boissons sans alcool, les livres, les journaux, les revues et les médicaments). Il vous est indiqué que les deux taux de TVA pourraient être amenés à changer au cours du temps.

Q1 : Concernant les données initiales, celles qui sont nécessaire pour réaliser le traitement, il est nécessaire d’avoir :

les deux taux de TVA
le prix unitaire HT du produit
le nombre d’unités du produit

Incorrect : il manque la catégorie du produit. Le programme devra déterminer le bon taux de TVA en fonction de la catégorie du produit. Il est donc nécessaire de la connaître.

les deux taux de TVA
le prix unitaire HT du produit
le nombre d’unités du produit
la catégorie du produit

Correct : Avec toutes ces données, vous disposez de tous les élements pour calculer le prix TTC.

les deux taux de TVA
le prix unitaire HT du produit
le nombre d’unités du produit
le nom du produit
la catégorie du produit

Incorrect : le nom du produit n’a pas d’utilité pour le traitement. Lorsqu’on définit les variables nécessaires, il faut éviter de définir des variables inutiles. Même si chaque produit a un nom, cette information ne sera pas utilisée pour le traitement. La catégorie est suffisante. On peut imaginer une solution plus ambitieuse qui identifierait la catégorie du produit en fonction de son nom. Mais dans ce cas, la catégorie serait inutile.

une variable pour le prix unitaire HT du produit
une variable pour le nombre d’unités du produit
une variable pour la catégorie du produit

Incorrect : Même si vous connaissez à l’avance les montants des deux taux de TVA, il faut que ces deux données soient disponibles dans le programme. Il serait possible d’utiliser directement les valeurs des taux pour faire les calculs, mais il vous a été signalé que ces taux pourraient changer. Dans ce cas, il est plus efficace d’utiliser deux variables dont vous pourrez ajuster les valeurs en cas de changement de taux.

Q2 : Quelles sont les données intermédiaires ?

Aucune

Incorrect : Il manque une donnée nécessaire pour calculer le prix total TTC.

Le taux de TVA appliqué

Correct : Initialement, les deux taux de TVA sont connus, mais il faut sélectionner lequel des deux taux utiliser pour la calcul.

Le nombre d’unités du produit

Incorrect : le nombre d’unités du produit ne peut pas être calculé, il fait partie des données initiales à obtenir au début du programme.

Le taux de TVA appliqué
Le montant total HT

Correct : il est possible de réaliser le calcul en deux étapes : d’abord le calcul du prix total HT, puis le prix total TTC. Dans la pratique, on essaie autant que possible de limiter le nombre des variables. Même si elle est correcte, cette solution n’est pas la plus pertinente.

Q3 : Quelles sont les données résultats ?

Le prix total TTC

Correct : Le prix total TTC est effectivement le résultat attendu.

Le montant de TVA appliqué
Le prix total TTC

Correct : Même si le montant de TVA appliqué n’est pas explicitement exigé, il est déterminé pendant le traitement et il peut être intéressant de le communiquer à l’utilisateur en plus du prix total TTC.

Le prix unitaire du produit
Le prix total TTC

Incorrect : le prix unitaire du produit est une donnée initiale. Elle est déjà connue de l’utilisateur. Elle peut lui être rappelée à la fin du traitement, mais on ne la considérera pas comme un résultat.

Q4 : Quel nom de variable sera le plus approprié pour le prix unitaire du produit ?

a
Incorrect : Les noms des variables doivent être choisis de façon à indiquer leur rôle dans le traitement afin de faciliter leur utilisation.

Le_prix_unitaire_du_produit

Incorrect : Les noms des variables doivent être choisis de façon à indiquer leur rôle dans le traitement, mais il faut aussi préférer des noms qui soient le plus compact possible.

Prix_unitaire

Correct : le nom est à la fois compact et significatif du rôle que tiendra la variable dans le traitement.

Prix_U

Incorrect : le nom choisi ici reste trop ambigu sur la signification du U, même s’il peut être deviné. Il vaut mieux être le plus explicite possible.

Q5 : Il faut déterminer les actions d’initialisation des données d’entrée

Saisir les deux taux de TVA
Saisir le prix unitaire du produit
Saisir la catégorie du produit

Incorrect : les taux de TVA sont connus, ils ne doivent pas être saisis.

Affecter les deux valeurs des taux de TVA
Saisir le prix unitaire du produit
Saisir la catégorie du produit

Correct : Les deux taux de TVA sont connus, leurs valeurs peuvent être directement affectées aux variables concernées. Le prix unitaire du produit et la catégorie du produit ne peuvent pas être connus, ni calculés, ils doivent donc être saisis par l’utilisateur du programme (dans des conditions réelles, le prix et la catégorie du produit seraient déterminés à partir du code barre disposé sur l’emballage du produit).

Affecter les deux valeurs des taux de TVA
Saisir le prix unitaire du produit

Incorrect : la catégorie du produit ne peut pas être calculée ou déduite des autres données, il faut donc qu’elle soit saisie par l’utilisateur.

Q6 : Quels sont les traitements/calculs principaux du programme et dans quel ordre ?

Calculer le prix TTC à payer
Déterminer le taux de TVA à appliquer

Incorrect : La formule de calcul du prix TTC nécessite de connaître le taux de TVA à appliquer. Il faut donc le déterminer avant le calcul.

Déterminer le taux de TVA à appliquer
Calculer le prix TTC à payer

Correct : La formule de calcul du prix TTC dépend du prix unitaire, du nombre d’unités et du taux de TVA. Prix unitaire et nombre d’unités sont saisis au début du programme par l’utilisateur et le taux de TVA à appliquer est déterminé avant de faire le calcul du prix.

Calculer le prix TTC à payer

Incorrect : la formule de calcul du prix à payer nécessite de connaître le taux de TVA à appliquer. Or il y a deux taux possibles. Il faut donc préalablement déterminer le taux à appliquer.

Q7 Comment déterminer le taux de TVA à appliquer ?

Tant que (le taux n’est pas le bon) changer le taux

Incorrect : il y a deux taux de TVA possibles. Le choix se fait en une seule fois selon un critère : la catégorie du produit. Une boucle n’est pas appropriée.

Si (catégorie est denrées alimentaires et boissons sans alcool et livres et journaux et revues et médicaments) alors le taux vaut le taux réduit
Sinon le taux vaut le taux normal

Incorrect : la catégorie du produit ne peut pas valoir toutes les catégories à la fois.

Si (catégorie est denrées alimentaires ou boissons sans alcool ou livres ou journaux ou revues ou médicaments) alors le taux vaut le taux réduit
Sinon le taux vaut le taux normal

Correct : Un si alors sinon permet de tester la valeur de la catégorie et de choisir le taux à appliquer parmi les deux taux existants. Il suffit que la catégorie du produit soit une des catégories listées comme produit à taux réduit pour que le taux soit le taux réduit.

Si (catégorie est denrées alimentaires ou boissons sans alcool ou livres ou journaux ou revues ou médicaments) alors le taux vaut le taux normal
Sinon le taux vaut le taux réduit

Incorrect : 

Si (catégorie est différent de denrées alimentaires et boissons sans alcool et livres et journaux et revues et médicaments) alors le taux vaut le taux normal
Sinon le taux vaut le taux réduit

Correct : Un si alors sinon permet de tester la valeur de la catégorie et de choisir le taux à appliquer parmi les deux taux existants. Il suffit que la catégorie du produit soit différent des catégories listées comme produit à taux réduit pour que le taux soit le taux normal.s