## String or Char

In this quiz, you’ll be asked whether an element belongs to the Char type or the String type.

Passing grade: 80%
Duration: 5 min
Quiz type: Instructional/Certifying

Q1 : 
```scala
'a'
```
Question type: 
- Single correct answer 


Answers:
- Char  Correct -> Yes, this is a value of the Char type, which can be inferred from the single quotes surrounding it (').
- String  Wrong -> a is not a string, as can be inferred from the characters surrounding it.


Q2 :
```scala
"b"
```
Question type: 
- Single correct answer


Answers:
Correct/Wrong -> Feedback if selected 
- Char  Wrong -> b is not of the Char type, as evidenced by the characters surrounding it.
- String  Correct -> Yes, this is a value of the String type, which can be inferred from the double quotes surrounding it ('').


Q3 : 
```scala
"Coffee gets me up in the morning."
```
Question type: 
- Single correct answer

Answers:
- Char  Correct/Wrong -> By definition, a Char value can only consist of a single character. Furthermore, the values are not surrounded by single-quotes.
- String  Correct -> Yes, this is a String value, which can contain every character one after the other.
- Neither  Wrong -> This value is in fact one of the two. You can determine which by looking at the characters surrounding the value.

Q4: 
```scala
'this is a Char or a String'
```
Question type: 
- Single correct answer 

Answers:
- Char  Wrong -> This is not a valid Char type, even though it is surrounded by single-quotes ('). By definition, a Char value can only consist of a single character.
- String  Wrong -> This cannot be a String value, because strings are surrounded by double-quotes (").
- Neither  Correct -> Indeed, the value shown is surrounded by single-quotes ('), which are used for Char values, but a Char value can only contain a single character.

Q5: 
```scala
"Char"
```
Question type: 
- Single correct answer 

Answers:
- Char  Wrong -> This is not a Char-type value. The characters surrounding it are wrong. By definition, a Char value can only consist of a single character.
- String  Correct -> Yes, this is a String-type value. It is surrounded by double-quotes ("). Even though Char is the word reserved in Scala to designate the Character type, the double-quotes (") surrounding it mean the value is of the type String: Char. 
- Neither  Wrong -> Take a close look at how the value is written. It matches one of the two types for text. 

Q6: 
```scala
''
```
Question type: 
- Single correct answer 

Answers:
- Char  Wrong -> This is not a valid Char-type value. There is no such thing as an "empty" character. At best you could have the value ' ' representing the Space character.
- String  Wrong -> This cannot be a String-type value, given the characters surrounding the value.
- Neither  Correct -> A character chain can be empty, that is, contain no characters. This would be represented as "". But a character itself cannot be "empty". 


Q7: 
```scala
'\n'
```
Question type: 
- Single correct answer 

Answers:
- Char  Correct -> Yes, this is a valid Char-type value. The value \n represents the character known as “newline”. This character exists but has no visual representation. So even though it consists of two characters, \n functions as a single character.
- String  Wrong -> This cannot be a String-type value, given the characters surrounding the value.
- Neither Wrong -> Even though this value contains more than one character while being surrounded by single-quotes, it does belong to one of the two Text types. 
