## Small blocks
Duration: 5 min
In this quiz, a problem is stated, and your task is to select the correct instruction block to solve it.

Q1: Which instruction block solves the following problem?
Question type: 
- Single correct answer 

At 8:00, 10:00 and 16:00 every Monday and Friday, tram line 12 gets inspected by tram agents. At the same times on Tuesdays and Thursdays, they inspect line 23. 

- Block 1
```scala
if(day == "Monday"){
    inspect(12)
}

if(day == "Friday"){
    inspect(12)
}
else { 
    inspect(23)
}
```
Wrong -> This would work if line 23 got inspected every day of the week except Monday and Friday, which is not the case.

- Block 2
```scala
if(day == "Thursday" || day == "Tuesday"){
    inspect(12)
}
else { 
    inspect(23)
}
```
Wrong -> This would work if the inspection of line 23 occurred every day of the week except Tuesday or Thursday, which is not the case.

- Block 3

```scala
if(day == "Monday"){
    inspect(12)
}else{
if(day == "Friday"){
    inspect(12)
}
else { 
    if (day == "Tuesday"){
        
        inspect(23)
        
    }
    
    if (day == "Thursday"){
        
        inspect(23)
    }       
    }
}
```
Wrong -> The controls for Monday/Friday and Tuesday/Thursday are not dependent.

- Block 4 

```scala
if(day == "Monday"){
    inspect(12)
}else{

if(day == "Friday"){
    inspect(12)
}else{
if (day == "Thursday" ){
     inspect(23)
}else{
if (day == "Tuesday"){
     inspect(23)
}
}
}
}
``` 
Correct -> The controls for Monday/Friday and Tuesday/Thursday are not dependent.

Q2 : Which instruction block defines the variable “number” as an integer in Scala?
Question type: 
- Single correct answer 

- Block 1
```scala

var integer = true 
if(integer) {
    var number = 0}
else{
    var number = 1.1
}
```
Correct -> The Boolean variable “integer” is initialized as true, so the value is set to 0.

- Block 2
```scala

var integer = false 
if(integer) {
    var number = 0}
else{
    var number = 1.1
}
```
Wrong -> The Boolean variable “integer” is initialized as false, so the value will be set, in Double, to 1.1.

- Block 3
```scala

var integer:Int = 0

if(integer) {
    var number = 0}
else{
    var number = 1.1
}
```
Wrong -> The variable “integer” is an integer initialized at 0 (not a Boolean), so the test of the variable “integer” will not work.
