# Quiz 

In this quiz, you will be asked to evaluate code segments that include conditional instructions and indicate whether each condition is correctly written or not. 


Passing grade: 80%
Duration: 5 min
Quiz type: Instructional/Certifying

Q1: Is this code correct?
Question type:
- Single correct answer 
```scala
var age = 10
if(20 > age) println("age less than 20")

```
- The conditional structure is correctly used.  Correct -> Yes, the conditional structure can be contained on a single line with no curly brackets.
- Curly brackets are missing around the println instruction.  Wrong -> The error here is something else.
- The parentheses are used incorrectly. Wrong -> The parentheses are used correctly in this example.

Q2:
Question type: 
- Single correct answer 
```scala
var  age = 10
if(20 > age) {println("age less than 20")}
else { 
    println("age greater than 20")
}
```

- The code is correctly written. Correct ->  Yes, this code will work just fine.
- There is an error in the code: the age variable should be a *val*, not a *var*. Wrong -> The code is fine. The variable age can be preceded by *var* or *val*.
- The code is wrong: the curly bracket that closes the *if* condition should be on the same line as the *else*  Wrong -> The code is correct. Connecting the *if*'s closing curly bracket with the *else* is just a matter of style.


Q3:
Question type: 
- Single correct answer 
```scala
var  age == 10
if(20 > age) println("age less than 20")

```
- The code is wrong: curly brackets are missing around the *println* instruction. Wrong ->  This instruction is correct.
- The code is wrong: there is an equal sign missing inside the *if* condition.  Wrong ->  The *if* condition is correct. There is an error, but somewhere else. 
- The code is wrong. Correct ->  The assignment of value 10 to the variable "age" is wrong. A test operator has mistakenly been used instead of the assignment symbol.

Q4: Which of the following are conditional instructions in Scala?
Question type: 
- Single correct answer 

- main and println  Wrong -> Those are methods.
- if and otherwise  Wrong -> there is no such thing as an “otherwise” instruction. 
- if and else  Correct -> *if* and *else* are both valid conditional instructions in Scala. 