## do while : pourquoi/pourquoi pas

Vous allez devoir répondre à un quiz présentant différent problèmes qui peuvent être résolus avec un __do while__ et/ou un __while__. Vous devez choisir la/les bonnes réponses en fonction du problème.

Seuil de réussite: 80%
Temps : 5 min
Fonction du quiz: Formative

Q1 : Une donnée doit être entrée par l'utilisateur dans un programme qui respecte la condition suivante : un nombre compris entre 1 et 100. Lesquelles des solutions respectent la consigne ?
Type de question: 
- Réponses correctes multiples

Réponses :

``` scala
var nombre = 200
do{
    nombre = readLine("Entrez un nombre: ").toInt
}while (nombre <= 1 && nombre <= 100)
```
Correct -> Bonne réponse, tant que la condition n'est pas respectée, le programme demandera d'entrer un nombre.

``` scala
var nombre = 200
while{
    nombre = readLine("Entrez un nombre: ").toInt
} do (nombre <= 1 && nombre <= 100)
```
Incorrect -> Mauvaise réponse, la syntaxe n'est pas correcte.


``` scala
var nombre = 0
while (nombre <= 1 && nombre <= 100){
    nombre = readLine("Entrez un nombre: ").toInt
}

```
Incorrect ->  Mauvaise réponse, la syntaxe n'est pas correcte, la variable __nombre__ n'a pas été initialisée.

``` scala
var nombre = 0
while (nombre <= 1 && nombre >= 100){
    nombre = readLine("Entrez un nombre: ").toInt
}

```
Correct -> Bonne réponse, tant que la condition n'est pas respectée, le programme demandera d'entrer un nombre.

Q2 : Quelle est la différence entre __while__ et __do while__ ?
Type de question:

- Réponse correcte unique

Réponses :

- Le contenu de la boucle avec do while est au moins exécuté une fois. Correct -> Bonne réponse, avec une boucle while, la condition est testée avant l'exécution de la boucle.
- Une boucle while est plus rapide qu'une boucle do while. Incorrect -> Mauvaise réponse, la vitesse d'exécution dépend ce qu'il y a dans les boucles.
- Une boucle do while ne peut générer une boucle infinie.  Incorrect -> Mauvaise réponse, ceci dépend uniquement de la condition. Les boucles do while et while peuvent être infinies.
