## do while: to use or not to use

In this quiz, you’ll be asked to determine whether to use a *do while* or *while* loop to solve various problems. You must choose the right answer(s) for each problem.

Passing grade: 80%
Duration: 5 min
Quiz type: Instructional

Q1: A value needs to be user-entered into a program; it needs to be a number between 1 and 100. Which of the following solutions meet these requirements?
Question type: 
- Multiple correct answers

Answers:

``` scala
var number = 200
do{
    number = readLine("Enter a number: ").toInt
}while (number <= 1 && number <= 100)
```
Correct -> Yes, as long as the condition remains false, the program will ask the user to enter a value.

``` scala
var number = 200
while{
    number = readLine("Enter a number: ").toInt
} do (number <= 1 && number <= 100)
```
Wrong -> No, the syntax is wrong here.


``` scala
var number = 0
while (number <= 1 && number <= 100){
    number = readLine("Enter a number: ").toInt
}

```
Wrong ->  The syntax is incorrect: the variable *number* was never initialized.

``` scala
var number = 0
while (number <= 1 && number >= 100){
    number = readLine("Enter a number: ").toInt
}

```
Correct -> Yes, as long as the condition remains false, the program will ask the user to enter a value.

Q2: What is the difference between a *while* and a *do while* loop?
Question type:

- Single correct answer

Answers:

- In a *do while*, the instruction in the loop is executed at least once.  Correct -> Yes, unlike a *while* loop, in which the condition is tested before the execution of the loop.
- A *while* loop is quicker than a *do while*.  Wrong -> No, execution speed depends on what is contained in the loop.
- A *do while* loop will never generate an infinite loop.  Wrong -> Whether a loop is infinite or not depends entirely on the condition. Both a *while* and a *do while* loop can be infinite.
