## Digression

Vous allez devoir répondre à un quiz présentant des déclarations variables et d'évaluer leur portés dans des boucles.

Seuil de réussite: 80%
Temps : 5 min 
Fonction du quiz: Formative

Q1 : Pourquoi ce code ne peut pas être compilé ?

``` scala
import scala.io.StdIn.readLine
do{

var argent = readLine("Combien d'argent avez-vous ?: ").toString
if(argent == "0") println("Vous n'avez pas d'argent.")
else println("Vous avez de l'argent.")

}while (argent == "0")

println("Vous avez "+ argent +" CHF")
```

Type de question:
- Réponse correcte unique

Réponses :
- La portée de la variable argent est uniquement dans le __do__, elle n'est donc pas accessible dans le reste du programme. Correct -> Bonne réponse.
- La variable argent n'est pas un Int. Incorrect -> Mauvaise réponse, peu importe le type de la variable, la variable argent n'est pas déclarée hors boucle.
- La portée du while ne permet pas la compilation. Incorrect -> Mauvaise réponse, while n'a pas de portée, mais argent en a une.

Q2 : Comment corriger le code suivant ? À vous de sélectionner le bloc de code qui permettra le fonctionnement du programme

```scala
import scala.io.StdIn.readLine
println("Simulateur de météo : pluie, soleil ou nuageux")

do{
    var meteo = readLine("Quel est le temps actuel ?: ").toString
    if (meteo.contains("pluie")) prinln("Le temps sera meilleur plus tard.")
    if (meteo.contains("soleil")) prinln("De la pluie est prévue pour plus tard.")
    if (meteo.contains("nuageux")) prinln("De la pluie ou du soleil sont prévus pour plus tard.")
}while (meteo.size == 0)
print("Vous aviez entrée : " + meteo)
```
Type de question:

- Réponse correcte unique
Réponses :

``` scala
 var meteo = ""
do{ ...
```
Correct -> Bonne réponse, il faut déclarer la variable meteo en amont du bloc __do__.

``` scala
do{ ...}
var meteo = ""
```
Incorrect -> Mauvaise réponse, déclarer la variable après le bloc __do__ ne la rendera pas accessible par les éléments contenus dans le bloc __do__.

``` scala
 
do{ ...}
while( var meteo = "" 
  meteo.size == 0   )
```

Incorrect -> Mauvaise réponse, déclarer la variable dans la condition du __do while__ ne la rendera pas accessible par les éléments contenus dans le bloc __do__.
