## Choose the right method

In this quiz, you’ll be given a problem, then asked to choose the right array method to solve it.

Passing grade: 80%
Duration: 5 min
Quiz type: Instructional

Q1: How would you define an array of size 20 and fill it with 1’s?

Question type:

- Single correct answer

Answers:

- val myArray = Array.fill(1)(20)  Wrong -> No, the argument passed to the *fill* method needs to be the array size.
- val myArray = Array.fill(20)(1)  Correct ->  Yes, here the *fill* method initializes all of the array's elements.
- val myArray = Array.tabulate(1)(20)  Incorrect -> No, the *tabulate* method is used to fill an array using an expression.

Q2: How would you display the following array in the console, then return the sum of its elements? 
val myArray = Array(1, 2, 3, 4)

Question type:

- Single correct answer 

Answers:

- myArray.mkString myArray.sum  Correct -> Yes, the *mkString* method also takes a limiter as an argument, which is used when displaying results.
- myArray.String myArray.sum  Wrong -> There is no such method as myArray.String.
- myArray.mkString myArray.addall  Wrong -> There is no such method as myArray.addall.

Q3: How would you sort the following array in decreasing order?
val myArray = Array(6,19,3,78,25,29,42,68)

Question type:

- Single correct answer

Answers:

- myArray.sorted.reverse  Correct -> Yes, the *sorted* method followed by *reverse* will sort the array in decreasing order. First the elements are sorted in increasing order, then *reverse* reverses the order of the array.
- myArray.reverse.sorted  Wrong -> No, if you apply *reverse* before *sorted*, the latter will undo the effects of the former.
- myArray.sorted  Wrong -> No, by default, *sorted* puts the array elements in increasing order.
