# Etude de cas : Morpion

## Énoncé
Écrire un programme qui permet à deux utilisateurs de jouer au jeu du 
Morpion (Tic-tac-toe) https://fr.wikipedia.org/wiki/Tic-tac-toe. 
Le jeu se joue tour à tour. Il est basé sur une grille de taille 3 par 3.
Chaque joueur, chacun à leur tour, doit entrer dans une case de la grille 
le symbole qui leur est attribué : O ou X.  Le gagnant est celui qui arrive à
aligner trois symboles identiques, horizontalement, verticalement ou en diagonale.
Il est possible que aucun des joueurs ne gagne. Une fois que la grille est complète 
(aucun coup possible) ou qu'un joueur gagne, le programme devra afficher un message :
"Fin de Partie : Joueur ... a gagné" ou alors "Fin de Partie : Match nul".
Vous devez utiliser des méthodes pour écrire ce programme.

## Solution

La jeu se joue à travers une grille, il faudra donc utiliser un tableau de taille 3x3 pour
contenir les symboles entrés par les joueurs. Une boucle __while__ devra être utilisée pour demander 
aux joueurs d'entrer leur coup, d'afficher le tableau, de vérifier que personne n'a gagné et
enfin de passer la main au joueur suivant. Il faudra donc aussi écrirer des méthodes qui
réaliseront ses actions :

- Afficher le tableau
- Vérifier si le tableau contient trois symboles identiques, horizontalement, verticalement ou en diagonale, signe qu'un joueur à gagné
- Définir quel joueur commence de manière aléatoire
- Définir quel joueur doit jouer pour le tour suivant
- Entrer l'action du joueur dans le tableau

Enfin, toutes les méthodes seront utilisées dans le __main__ et dans la bouche __while__.


# Production de code : Morpion

Vous allez devoir définir et coder différentes méthodes permettant la réalisation 
d'un jeu de morpion en utilisant votre travail de l'étude de cas précédente et de sa solution.


## Solution


```scala
import java.lang.Boolean
import io.StdIn

object game {
    def main(args: Array[String]): Unit = {
        var matrix = Array.ofDim[String](3,3)
        var tab = Array.fill(10)(0)
        var gagne = false

        println("Bienvenue dans Morpion 3000")

        afficher(matrix)

        var joueur = quiCommence()
        println("Le joueur " + joueur + " commence la partie.")

        while(gagne == false){
            println("Coup du joueur : " + joueur)
            val x = StdIn.readLine("Coordonnée x: ").toInt
            val y = StdIn.readLine("Coordonnée y: ").toInt

            matrix = action(joueur,x,y,matrix)
            afficher(matrix)
            gagne = verif(matrix)
            joueur = aQuiLeTour(joueur)
        }
        println("Fin de Partie")
        afficher(matrix)
    }
    
    def afficher(mat:Array[Array[String]]): Unit={
        for{i <- 0 until 3}{ //ligne
            for{j <- 0 until 3}{ //colone
                print("|" + mat(i)(j) + "|")  
            }
        println()
        }
    }
  
    def aQuiLeTour(joueur:String):String={
        if(joueur == "X"){
            return "O"
        } 
        else {
            return "X"
        }
    }
  
    def quiCommence():String={
    
        val random = new scala.util.Random
        val jrs = Array("X","O")
        return jrs(random.nextInt(2))
    }
  
    def action(joueur:String,i:Int,j:Int,mat:Array[Array[String]]):Array[Array[String]]={
        if(mat(i)(j) == null){
            mat(i)(j)=  joueur
            return mat
        }
        else {
            return mat
        }
    }
  
    def verif(mat:Array[Array[String]]): Boolean ={
        val gagneligne =  Array(Array("XXX"),Array("OOO"))
        
        for (x <- mat){
            if(x.mkString.contains(gagneligne(0).mkString) || x.mkString.contains(gagneligne(1).mkString)){
                return true
            }
        }
        
        for (x <- mat.transpose){
            if(x.mkString.contains(gagneligne(0).mkString) || x.mkString.contains(gagneligne(1).mkString)){
                return true
            }
        }

        for{i <- 0 until 3}{
            for{j <- 0 until 3}{
                if(mat(i)(j) == null){
                    return false
                }
            }

        }
        return false
    }
}
```
