# Try/Catch

Vous allez devoir répondre à un quiz sur les exceptions en Scala.

Seuil de réussite: 80%
Temps 10 min
Fonction du quiz: Formative

Q1 : Laquelle des clauses est facultative ?

Type de question:

- Réponses correctes unique
Réponses :

- catch Incorrect -> catch est obligatoire.
- try Incorrect -> try est obligatoire.
- finally Correct -> finally est facultative.

Q2 : Dans quel ordre s'utilisent les clauses pour gérer les exceptions ?

Type de question:

- Réponses correctes multiples

Réponses :

- catch->finally->try Incorrect -> Faux, try doit être en première position.
- try->finally-catch Incorrect -> Faux, catch doit être placé avant finally.
- try->catch->finally Correct -> Vrai, c'est l'ordre classique avec la clause facultative.
- try->catch Correct -> Vrai, c'est l'ordre classique

Q3 : Dans quel cas utiliser la gestion des exceptions ?

Type de question:

- Réponses correctes multiples

Réponses :

- Pour accéder (lire/écrire) à un fichier dont l'existence n'est pas certaine. Correct -> Vrai, c'est l'erreur java.io.FileNotFoundException
- Lors d'une conversion d'une variable String en valeur numérique alors que la variable ne correspond pas à une valeur numérique. Correct -> Vrai, c'est l'erreur java.lang.NumberFormatException.
- Pour tester si une variable est un fichier. Incorrect -> Faux, il faut regarder le type de la variable.

Q4 : Dans la clause catch, qu'indique "_" ?

Type de question:

- Réponses correctes unique

Réponses :

- Instruction à exécuter si la clause try inclut une erreur d'ouverture de fichier. Incorrect -> Faux, c'est la condition générale, l'erreur d'ouverture de fichier est java.io.FileNotFoundException.
- Instruction à exécuter si la clause try inclut une erreur d'un type non spécifique (cas général). Correct -> Vrai, c'est la condition générale.
- Instruction à exécuter si la clause try inclut une erreur d'accès à un fichier protégé. Incorrect -> Faux, c'est la condition générale, l'erreur d'accès à un fichier protégé est java.nio.file.AccessDeniedException.

Q5 : Que permet de faire la clause catch ?

Type de question:

- Réponses correctes unique

Réponses :

- Elle permet de tester l'exécution d'une instruction sur une variable. Incorrect -> Faux, c'est une expression.
- Elle permet d'attraper les erreurs. Correct -> Vrai, catch permet d'attraper les erreurs et de pouvoir les gérer sans que le programme s'arrête.
- Elle permet de lire un fichier texte. Incorrect -> Faux, la lecture de fichier n'est pas une fonctionnalité de catch.
